PHTTPClientDigestAuthentication Class Reference

`#include <http.h>`

Inheritance diagram for PHTTPClientDigestAuthentication:

## Public Types

enum | Algorithm { Algorithm_MD5, NumAlgorithms }
Public Types inherited from PObject
enum | Comparison { LessThan = -1, EqualTo = 0, GreaterThan = 1 }
| Result of the comparison operation performed by the `Compare()` function. More...

## Public Member Functions

| PHTTPClientDigestAuthentication ()
PHTTPClientDigestAuthentication & | operator= (const PHTTPClientDigestAuthentication &auth)
virtual Comparison | Compare (const PObject &other) const
| Compare the two objects and return their relative rank. More...
virtual PBoolean | Parse (const PString &auth, PBoolean proxy)
virtual PBoolean | Authorise (AuthObject &pdu) const
virtual PString | GetAuthRealm () const
virtual void | SetAuthRealm (const PString &r)
const PString & | GetNonce () const
Algorithm | GetAlgorithm () const
const PString & | GetOpaque () const
bool | GetStale () const
Public Member Functions inherited from PHTTPClientAuthentication
| PHTTPClientAuthentication ()
virtual PBoolean | IsProxy () const
virtual PString | GetUsername () const
virtual PString | GetPassword () const
virtual void | SetUsername (const PString &user)
virtual void | SetPassword (const PString &pass)
PString | GetAuthParam (const PString &auth, const char *name) const
PString | AsHex (PMessageDigest5::Code &digest) const
PString | AsHex (const PBYTEArray &data) const
Public Member Functions inherited from PObject
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
virtual PINDEX | HashFunction () const
| This function yields a hash value required by the `PDictionary` class. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Protected Attributes

PString | authRealm
PString | nonce
Algorithm | algorithm
PString | opaque
bool | qopAuth
bool | qopAuthInt
bool | stale
PString | cnonce
PAtomicInteger | nonceCount
Protected Attributes inherited from PHTTPClientAuthentication
PBoolean | isProxy
PString | username
PString | password

## Additional Inherited Members

Static Public Member Functions inherited from PHTTPClientAuthentication
static PHTTPClientAuthentication * | ParseAuthenticationRequired (bool isProxy, const PMIMEInfo &line, PString &errorMsg)
Static Public Member Functions inherited from PObject
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
static const char * | Class ()
| Get the name of the class as a C string. More...
Protected Member Functions inherited from PObject
| PObject ()
| Constructor for PObject, made protected so cannot ever create one on its own. More...

## Member Enumeration Documentation

## Algorithm

enum PHTTPClientDigestAuthentication::Algorithm

Enumerator
Algorithm_MD5 |
NumAlgorithms |

## Constructor & Destructor Documentation

## PHTTPClientDigestAuthentication()

PHTTPClientDigestAuthentication::PHTTPClientDigestAuthentication | ( |  | ) |

## Member Function Documentation

## Authorise()

virtual PBoolean PHTTPClientDigestAuthentication::Authorise | ( | AuthObject & | pdu | ) | const

virtual

Implements PHTTPClientAuthentication.

## Compare()

virtual Comparison PHTTPClientDigestAuthentication::Compare | ( | const PObject & | obj | ) | const

virtual

Compare the two objects and return their relative rank.

This function is usually overridden by descendent classes to yield the ranking according to the semantics of the object.

The default function is to use the `CompareObjectMemoryDirect()` function to do a byte wise memory comparison of the two objects.

Returns
  `LessThan`, `EqualTo` or `GreaterThan` according to the relative rank of the objects.

Reimplemented from PHTTPClientAuthentication.

## GetAlgorithm()

Algorithm PHTTPClientDigestAuthentication::GetAlgorithm | ( |  | ) | const

inline

## GetAuthRealm()

virtual PString PHTTPClientDigestAuthentication::GetAuthRealm | ( |  | ) | const

inline virtual

Reimplemented from PHTTPClientAuthentication.

## GetNonce()

const PString& PHTTPClientDigestAuthentication::GetNonce | ( |  | ) | const

inline

## GetOpaque()

const PString& PHTTPClientDigestAuthentication::GetOpaque | ( |  | ) | const

inline

## GetStale()

bool PHTTPClientDigestAuthentication::GetStale | ( |  | ) | const

inline

## operator=()

PHTTPClientDigestAuthentication& PHTTPClientDigestAuthentication::operator= | ( | const PHTTPClientDigestAuthentication & | auth | ) |

## Parse()

virtual PBoolean PHTTPClientDigestAuthentication::Parse | ( | const PString & | auth,
|  | PBoolean | proxy
| ) |  |

virtual

Implements PHTTPClientAuthentication.

## SetAuthRealm()

virtual void PHTTPClientDigestAuthentication::SetAuthRealm | ( | const PString & | r | ) |

inline virtual

Reimplemented from PHTTPClientAuthentication.

## Member Data Documentation

## algorithm

Algorithm PHTTPClientDigestAuthentication::algorithm

protected

## authRealm

PString PHTTPClientDigestAuthentication::authRealm

protected

## cnonce

PString PHTTPClientDigestAuthentication::cnonce

protected

## nonce

PString PHTTPClientDigestAuthentication::nonce

protected

## nonceCount

PAtomicInteger PHTTPClientDigestAuthentication::nonceCount

mutable protected

## opaque

PString PHTTPClientDigestAuthentication::opaque

protected

## qopAuth

bool PHTTPClientDigestAuthentication::qopAuth

protected

## qopAuthInt

bool PHTTPClientDigestAuthentication::qopAuthInt

protected

## stale

bool PHTTPClientDigestAuthentication::stale

protected

The documentation for this class was generated from the following file:

- http.h